// ======================================================================
// \title  S3SerializableAc.cpp
// \author Generated by fpp-to-cpp
// \brief  cpp file for S3 struct
// ======================================================================

#include "cstdio"
#include "cstring"

#include "Fw/Types/Assert.hpp"
#include "Fw/Types/StringUtils.hpp"
#include "S3SerializableAc.hpp"

namespace S {

  // ----------------------------------------------------------------------
  // Constructors
  // ----------------------------------------------------------------------

  S3 ::
    S3() :
      Serializable(),
      mF64(0.0)
  {
    for (NATIVE_UINT_TYPE i = 0; i < 3; i++) {
      this->mU32Array[i] = 0;
    }
  }

  S3 ::
    S3(
        const Type_of_mU32Array& mU32Array,
        F64 mF64
    ) :
      Serializable(),
      mF64(mF64)
  {
    for (NATIVE_UINT_TYPE i = 0; i < 3; i++) {
      this->mU32Array[i] = mU32Array[i];
    }
  }

  S3 ::
    S3(const S3& obj) :
      Serializable(),
      mF64(obj.mF64)
  {
    for (NATIVE_UINT_TYPE i = 0; i < 3; i++) {
      this->mU32Array[i] = obj.mU32Array[i];
    }
  }

  S3 ::
    S3(
        U32 mU32Array,
        F64 mF64
    ) :
      Serializable(),
      mF64(mF64)
  {
    for (NATIVE_UINT_TYPE i = 0; i < 3; i++) {
      this->mU32Array[i] = mU32Array;
    }
  }

  // ----------------------------------------------------------------------
  // Operators
  // ----------------------------------------------------------------------

  S3& S3 ::
    operator=(const S3& obj)
  {
    if (this == &obj) {
      return *this;
    }

    set(obj.mU32Array, obj.mF64);
    return *this;
  }

  bool S3 ::
    operator==(const S3& obj) const
  {
    // Compare non-array members
    if (!(this->mF64 == obj.mF64)) {
      return false;
    }

    // Compare array members
    if (!(this->mU32Array == obj.mU32Array)) {
      for (NATIVE_UINT_TYPE i = 0; i < 3; i++) {
        if (!(this->mU32Array[i] == obj.mU32Array[i])) {
          return false;
        }
      }
    }

    return true;
  }

  bool S3 ::
    operator!=(const S3& obj) const
  {
    return !(*this == obj);
  }

#ifdef BUILD_UT

  std::ostream& operator<<(std::ostream& os, const S3& obj) {
    Fw::String s;
    obj.toString(s);
    os << s.toChar();
    return os;
  }

#endif

  // ----------------------------------------------------------------------
  // Member functions
  // ----------------------------------------------------------------------

  Fw::SerializeStatus S3 ::
    serialize(Fw::SerializeBufferBase& buffer) const
  {
    Fw::SerializeStatus status;

    for (NATIVE_UINT_TYPE i = 0; i < 3; i++) {
      status = buffer.serialize(this->mU32Array[i]);
      if (status != Fw::FW_SERIALIZE_OK) {
        return status;
      }
    }
    status = buffer.serialize(this->mF64);
    if (status != Fw::FW_SERIALIZE_OK) {
      return status;
    }

    return status;
  }

  Fw::SerializeStatus S3 ::
    deserialize(Fw::SerializeBufferBase& buffer)
  {
    Fw::SerializeStatus status;

    for (NATIVE_UINT_TYPE i = 0; i < 3; i++) {
      status = buffer.deserialize(this->mU32Array[i]);
      if (status != Fw::FW_SERIALIZE_OK) {
        return status;
      }
    }
    status = buffer.deserialize(this->mF64);
    if (status != Fw::FW_SERIALIZE_OK) {
      return status;
    }

    return status;
  }

#if FW_SERIALIZABLE_TO_STRING || BUILD_UT

  void S3 ::
    toString(Fw::StringBase& sb) const
  {
    static const char* formatString =
      "( "
      "mU32Array = [ %" PRIu32 ", "
      "%" PRIu32 ", "
      "%" PRIu32 " ], "
      "mF64 = %f"
      " )";

    char outputString[FW_SERIALIZABLE_TO_STRING_BUFFER_SIZE];
    (void) snprintf(
      outputString,
      FW_SERIALIZABLE_TO_STRING_BUFFER_SIZE,
      formatString,
      this->mU32Array[0],
      this->mU32Array[1],
      this->mU32Array[2],
      this->mF64
    );

    outputString[FW_SERIALIZABLE_TO_STRING_BUFFER_SIZE-1] = 0; // NULL terminate
    sb = outputString;
  }

#endif

  // ----------------------------------------------------------------------
  // Setter functions
  // ----------------------------------------------------------------------

  void S3 ::
    set(
        const Type_of_mU32Array& mU32Array,
        F64 mF64
    )
  {
    this->mF64 = mF64;

    for (NATIVE_UINT_TYPE i = 0; i < 3; i++) {
      this->mU32Array[i] = mU32Array[i];
    }
  }

  void S3 ::
    setmU32Array(const Type_of_mU32Array& mU32Array)
  {
    for (NATIVE_UINT_TYPE i = 0; i < 3; i++) {
      this->mU32Array[i] = mU32Array[i];
    }
  }

  void S3 ::
    setmF64(F64 mF64)
  {
    this->mF64 = mF64;
  }

}
